#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_QianDao.h"
std::auto_ptr<M_QianDao> M_QianDao::msSingleton(nullptr);

int M_QianDao::GetCount()
{
	return (int)mMapData.size();
}

const M_QianDaoData* M_QianDao::GetData(int Day)
{
	auto it = mMapData.find(Day);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_QianDaoData>& M_QianDao::GetMapData()
{
	return mMapData;
}

void M_QianDao::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_QianDao.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_QianDaoData data;
		data.mDay = element->IntAttribute("Day");
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		{
			const char* ItemNumber = element->Attribute("ItemNumber");
			std::vector<std::string> vecItemNumber;
			boost::split(vecItemNumber, ItemNumber, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemNumber.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemNumber[i].c_str(), &temp))
				{
					data.mItemNumber.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		CCASSERT(mMapData.find(data.mDay) == mMapData.end(), "data.mDay is exists");
		mMapData.insert(std::make_pair(data.mDay, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_QianDao Loaded. Load Data:%u", mMapData.size());
}

void M_QianDao::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_QianDao");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_QianDao");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_QianDaoData data;
		LuaCfgHelper::readInt(L, "Day", data.mDay);
		LuaCfgHelper::readVectorInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readVectorInt(L, "ItemNumber", data.mItemNumber);
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		CCASSERT(mMapData.find(data.mDay) == mMapData.end(), "data.mDay is exists");
		mMapData.insert(std::make_pair(data.mDay, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_QianDao Loaded. Load Data:%u", mMapData.size());
}

void M_QianDao::Reload()
{
	mMapData.clear();
	Load();
}

M_QianDao* M_QianDao::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_QianDao());
	}
	return msSingleton.get();
}

void M_QianDao::Release()
{
	msSingleton.reset(nullptr);
}
